      program attractmulti
c
c main program
c This program performs a systematic docking search.
c usage: $path/attractmulti receptor.pdb ligand.pdb parameterfile
c It requires the following files:
c  translate.dat, rotation.dat, standard.pdb,attract.inp
c Author: Martin Zacharias, Jacobs University Bremen
c
      include "CADD.t"
      character*80 b,eingabe,eingabe1,eingabe2,filnam
      character*4 atyp(20),rg(7500),rgi(7500),tyi(7500),ty(7500),at,
     1            au,av,typa
      dimension ka(7500),kai(7500),ipol(50),nphi(20),iblo(10,10),
     1          ialpst(7500),iflo(31,31),lisrec(22500),iill(7500),
     2          lislig(22500),ipoint(7500)
      dimension rad(50),amp(50),xla(22500),xlai(22500),theta(20),
     1          blo(10,2),xzr(22500),ceest(3),ceend(3),abc(31,31)
c    2          rbc(31,31)
      dimension sasa(22500),sasaf(22500),radi(31),solv(31),csth(80),
     1 snth(80),cphgh(80),sphgh(80),xcrd(9000),ycrd(9000),zcrd(9000)
      dimension ity(9000)
      data (atyp(j),j=1,20)/'ASP ','GLU ','LYS ','ARG ','HIS ','ASN ',
     1 'GLN ','SER ','THR ','CYS ','ALA ','VAL ','ILE ','LEU ','MET ',
     2 'TYR ','TRP ','PHE ','GLY ','PRO '/
c  read file names from command line
      call getarg(1,eingabe) 
      call getarg(2,eingabe1)
      call getarg(3,eingabe2)
c  set some parameters
      permi=15.0D0
      one=1.0D0
      zwei=2.0D0
      xnull=0.0d0
      felec=332.053986d0
      felec=sqrt(felec/permi)
      pi=3.141592654d0
      zwopi=2.0d0*pi
      igb=0
      iconf=1
c
c open and read receptor file
c
      open(42,file=eingabe)
      i=0
      iold=0
      irs=0
      irso=0
      izz=1
   40 read(42,20,end=30) b
      if(b(:4).eq.'ATOM') then
      read(b,26) at,ka(i+1),ty(i+1),rg(i+1),ie(i+1),xc(3*i+1),
     1  xc(3*i+2),xc(3*i+3),iac(i+1),xla(i+1),icopr(i+1),wer(i+1)
      cha(i+1)=felec*xla(i+1)
      ka(i+1)=i+1
c
c this for renumbering of residues
c and identificatin of conformational copies of side chains or loop segments
c
      if(ie(i+1).ne.irso) then
      irso=ie(i+1)
      irs=irs+1
      iold=0
      endif
      ie(i+1)=irs
      if(icopr(i+1).ne.0) then
      izz=izz+1
      else
      izz=0
      endif
      if(icopr(i+1).ne.iold) then
      izz=1
      iold=icopr(i+1)
      endif
c array for the atoms (izz) of each copy (iold) of a residue (irs)
      ncoprez(irs,iold,izz)=i+1
c max number of copies of residue irs 
      nmaxcor(irs)=icopr(i+1)
c max number of copies on residue irs 
      natcor(irs)=izz
      i=i+1
      if(ty(i).eq."CA  ") ialpr(ie(i))=i
      if(cha(i).ne.xnull) icha(i)=1
      imodel=1
      if(imodel.eq.0) then
      iac(i)=21
      do 11 j=1,20
      if(atyp(j).eq.rg(i).and.ty(i).ne.'CA  ') iac(i)=j
c     if(atyp(j).eq.rg(i)) iac(i)=j
   11 continue
      endif
      endif 
      goto 40
   30 close(42)
      nresr=ie(i)
      natom=i
      n3=3*natom
c calculate center of receptor
      ce(1)=xnull
      ce(2)=xnull
      ce(3)=xnull
      do 15 i=1,natom
      ii=3*(i-1)
      do 16 j=1,3
      ce(j)=ce(j)+xc(ii+j)
   16 continue
   15 continue
      do 18 j=1,3
      ce(j)=ce(j)/float(natom)
   18 continue
c open input file
      open(47,file='attract.inp')
      read(47,'(4i5)') ilauf,irez,ieigl,iharm
c     read(47,'(3i5,f9.2)') ilauf,irez,ieigl,encut
      read(47,'(4f10.5)') xrst,yrst,zrst,rstk
c
c  ilauf: number of energy minimizations
c  irez:  if 1: rezeptor forces in eigenvector direction are used
c  ieigl: if 1: ligand forces in eigenvector direction are used
c  
c  xrst,yrst,zrst: restrain origin, rstk=restrain force constant
c
      i=0 
      iold=0
      irs=0
      irso=0
      izz=1
      distalpa=1.0d10
c open and read ligand protein file
      open(43,file=eingabe1)
  200 read(43,20,end=226) b
      if(b(:4).eq.'ATOM') then
      read(b,26) at,kai(i+1),tyi(i+1),rgi(i+1),iei(i+1),x(3*i+1),
     1     x(3*i+2),x(3*i+3),iaci(i+1),xlai(i+1),icopl(i+1),wel(i+1)
      chai(i+1)=felec*xlai(i+1)
      kai(i+1)=i+1
c
c this for renumbering of residues
c and identificatin of conformational copies of side chains or loop segments
c
      if(iei(i+1).ne.irso) then
      irso=iei(i+1)
      irs=irs+1
      iold=0
      endif
      iei(i+1)=irs
      if(icopl(i+1).ne.0) then
      izz=izz+1
      else
      izz=0
      endif
      if(icopl(i+1).ne.iold) then
      izz=1
      iold=icopl(i+1)
      endif
c array for the atoms (izz) of each copy (iold) of a residue (irs)
      ncoplig(irs,iold,izz)=i+1
c max number of copies of residue irs 
      nmaxcol(irs)=icopl(i+1)
c max number of copies on residue irs 
      natcol(irs)=izz
      if(tyi(i+1).eq."CA  ") then
c this is to renumber residues
      ialpl(iei(i+1))=i+1
c this is to determine the CA that is closest to the center of the receptor
      disa=(x(3*i+1)-ce(1))**2+(x(3*i+2)-ce(2))**2+(x(3*i+3)-ce(3))**2 
         if(disa.le. distalpa) then
         distalpa=disa
         jrst=i
         endif
      endif
      i=i+1
      if(imodel.eq.0) then
      iaci(i)=21
      do 211 j=1,20
      if(atyp(j).eq.rg(i).and.ty(i).ne.'CA  ') iaci(i)=j
c     if(atyp(j).eq.rg(i)) iaci(i)=j
  211 continue
      endif
      if(chai(i).ne.xnull) ichai(i)=1
      endif
      goto 200
  226 close(43)
      nresl=iei(i)
      nlig=i
      n3l=3*nlig
      do 229 i=1,3
      ceest(i)=xnull
  229 continue
c
c read reference structure in file standard.pdb
c this structure is read to compare with the final ligand protein placement
c
      i=1
      istst=0
      ialst=0
      open(49,file='standard.pdb')
  238 read(49,20,end=239) b
      if(b(:4).eq.'ATOM') then
      ii=3*(i-1)
      read(b,'(13x,a4,5x,i4,4x,3f8.3)') typa,itypa,(xzr(ii+j),j=1,3)
      istst=istst+1
      ceest(1)=ceest(1)+xzr(ii+1)
      ceest(2)=ceest(2)+xzr(ii+2)
      ceest(3)=ceest(3)+xzr(ii+3)
      if(typa.eq."CA  ") then
      ialst=ialst+1
      ialpst(ialst)=i
      endif
      i=i+1
      endif
      goto 238
  239 close(49)
      do 241 i=1,3
      ceest(i)=ceest(i)/istst
  241 continue
c  create pointer of charged atoms
      ii=0
      do 244 i=1,natom
      if(icha(i).eq.1) then
      ii=ii+1
      ipoicha(ii)=i
      endif
  244 continue
      ipcham=ii
      ii=0
      do 245 i=1,nlig
      if(ichai(i).eq.1) then
      ii=ii+1
      ipoichal(ii)=i
      endif
  245 continue 
      ipchalm=ii
c     xrst=x(3*jrst+1)
c     yrst=x(3*jrst+2)
c     zrst=x(3*jrst+3)
      open(11,file=eingabe2)
      do 443 i=1,31
      read(11,*)(rbc(i,j),j=1,31)
  443 continue
      do 446 i=1,31
      read(11,*)(abc(i,j),j=1,31)
  446 continue
      do 447 i=1,31
      read(11,*)(iflo(i,j),j=1,31)
  447 continue
      close(11)
      do 450 j=1,31
      do 448 i=1,31
      rc(i,j)=abc(i,j)*rbc(i,j)**8
      ac(i,j)=abc(i,j)*rbc(i,j)**6
      emin(i,j)=-27.0d0*ac(i,j)**4/(256.0d0*rc(i,j)**3)
      rmin2(i,j)=4.0d0*rc(i,j)/(3.0d0*ac(i,j))
      ipon(i,j)=iflo(i,j)
  448 continue
  450 continue
c building electrostatics pairlist, no cutoff!
      jj=0 
      do 500 i=1,natom
      if(ipol(iac(i)).eq.2) then
      jj=jj+1
      irezept(jj)=i
      endif
  500 continue
      ncharez=jj
      jj=0
      do 510 i=1,nlig
      if(ipol(iaci(i)).eq.2) then
      jj=jj+1
      iligand(jj)=i
      endif
  510 continue
      nchalig=jj
c
c read harmonic modes, can be used if one wants to include receptor flexibility, 
c this is  under development, not well tested!
c
      if(ieigl.eq.1) then
      itest=int(n3l/6)
      irest=n3l-6*itest
      open(13,file='hml.dat')
      do 530 l=1,15
      read(13,*) kk,vall(l)
      vall(l)=2.5d0*vall(l)*vall(l)
      do 540 i=1,itest
      read(13,*)(eigl(l,6*(i-1)+j),j=1,6)
 540  continue
      if(irest.gt.0) read(13,*)(eigl(l,6*itest+j),j=1,irest)
      write(*,*) 'ligand eigenvector read ',l,kk,vall(l)
 530  continue
      close(13)
      write(*,*) ' check norm and orthogonality of eigenvectors'
      do 542 l=1,5
      eigvall=xnull
      do 545 j=1,n3l
      eigvall=eigvall+eigl(l,j)*eigl(l,j) 
 545  continue
      write(*,*) 'Norm of eigenvector ', l, eigvall
      eigvall=one/dsqrt(eigvall)
      do 546 j=1,n3l
      eigl(l,j)=eigvall*eigl(l,j)
      eigrot(l,j)= eigl(l,j)
 546  continue
      eigvall=xnull
      do 547 k=1,l
      do 548 j=1,n3l
      eigvall=eigvall+eigl(l,j)*eigl(k,j)
 548  continue
      write(*,*) 'Orthogonality of ligand eigenvectors ', l,k,eigvall
 547  continue
 542  continue
      endif
c   if iharm=1 read force constants for enm-model from file
      if(iharm.eq.1) then
      write(*,*)'force constants'
      open(51,file='harm.dat')
      do 550 i=1,nlig
      read(51,*)(hlm(i,j),j=1,nlig)
  550 continue
      do 552 i=1,natom
      read(51,*)(hrm(i,j),j=1,natom)
  552 continue
      close(51)
      endif
c
      if(irez.eq.1) then
      itest=int(n3/6)
      irest=n3-6*itest
      open(12,file='hmr.dat')
      do 555 l=1,10
      read(12,*) kk,val(l)
      val(l)=2.5d0*val(l)*val(l)
      do 560 i=1,itest
      read(12,*)(eig(l,6*(i-1)+j),j=1,6)
  560 continue
      if(irest.gt.0) read(12,*)(eig(l,6*itest+j),j=1,irest)
      write(*,*) 'eigenvector read ',l,kk,val(l)
  555 continue
      close(12)
c     write(*,*) ' check norm and orthogonality of eigenvectors'
      do 562 l=1,10
      eigval=xnull
      do 565 j=1,n3
      eigval=eigval+eig(l,j)*eig(l,j)
  565 continue
c     write(*,*) 'Norm of eigenvector ', l, eigval
      eigval=one/dsqrt(eigval)
      do 566 j=1,n3
      eig(l,j)=eigval*eig(l,j)
  566 continue
      eigval=xnull
      do 567 k=1,l
      do 568 j=1,n3
      eigval=eigval+eig(l,j)*eig(k,j)
  568 continue
c     write(*,*) 'Orthogonality of eigenvectors ', l,k,eigval
  567 continue
  562 continue
      endif
c setup of structure vectors 
      do 570 i=1,n3
      yc(iconf,i)=xc(i)
      xzz(i)=xc(i)
      yc(4,i)=xnull
  570 continue
      do 580 i=1,n3l
      y(iconf,i)=x(i)
  580 continue
      xa=xnull
      ya=xnull
      za=xnull
      do 585 i=1,nlig
      jj=3*(i-1)
      xa=xa+x(jj+1)
      ya=ya+x(jj+2)
      za=za+x(jj+3)
  585 continue
      xa=xa/float(nlig)
      ya=ya/float(nlig)
      za=za/float(nlig)
      do 590 i=1,nlig
      jj=3*(i-1)
      xb(jj+1)=x(jj+1)-xa
      xb(jj+2)=x(jj+2)-ya
      xb(jj+3)=x(jj+3)-za
      do 589 k=1,3
      x(jj+k)=xb(jj+k)
      xol(jj+k)=xb(jj+k)
  589 continue
  590 continue
      phi=xnull
      ssi=xnull
      rot=xnull
      eharm=xnull
      if(iharm.eq.1) call refdist
c  if isurf=1 (surface area calculations included)
c  set parameters for SASA calculation
      isurf=0
      if(isurf.eq.1) then
      mphi=8
      ncosth=5
      srad=1.4d0
      open(11,file='solv.dat')
      do 623 i=1,31
      read(11,'(i5,2f7.3)') ii,radi(i),solv(i)
  623 continue
      close(11)
      call surfpara(csth,snth,cphgh,sphgh,mphi,ncosth)
      endif
      rcon=7.0d0
      call contact(lisrec,lislig,xzr,ncon,rcon,natr,natl)
c
c get energy and forces
c
      imodel=0
c read theta,phi,rot data
      open(11,file='rotation.dat')
      read(11,*) ntheta,nrot
      do 593 i=1,ntheta
      read(11,*) theta(i),nphi(i)
      theta(i)=zwopi*theta(i)/360.0d0
      write(*,*) theta(i),nphi(i)
  593 continue
      close(11)
      do 595 i=1,ilauf
c reads: ivmax,ihes,iori,itra,irez,ieigl,neigl,neigen,irst,rcut into array
      read(47,'(i5,8i3,f9.2)') (iblo(i,j),j=1,9),blo(i,1)
c     write(*,'(i5,8i3,f9.2)') (iblo(i,j),j=1,9),blo(i,1)
  595 continue
      close(47)
c generate starting orientations, use data in rotation.dat for ssi,phi changes
      jcon=0
      open(12,file='translate.dat')
c out.dat will contain the final energies, rmsds etc. in one
c line per converged structure
      open(13,file='out.dat')
      read(12,*) ntrans
      do 597 ktrans=1,ntrans
c read starting placements
      read(12,31) ddx,ddy,ddz
c generate various initial ligand protein orientations
      do 600 kkk=1,ntheta
      do 620 jjj=1,nphi(kkk)
      do 640 iii=1,nrot
      ssi=theta(kkk)
      phii=zwopi/nphi(kkk)
      phi=jjj*phii
      rot=iii*zwopi/nrot
c this call does the rotations
      call anfang(x,xol,ssi,phi,rot,nlig)
c this loop does the initial placement (translation of ligand center)
      do 690 ij=1,nlig
      iij=3*(ij-1)
      y(iconf,iij+1)=x(iij+1)+ddx
      y(iconf,iij+2)=x(iij+2)+ddy
      y(iconf,iij+3)=x(iij+3)+ddz
  690 continue
      xa=ddx
      ya=ddy
      za=ddz
      jcon=jcon+1
      if(irez.eq.1) then
      do 695 i=1,neigen
      rez(i)=xnull
  695 continue
      do 697 i=1,n3
      yc(iconf,i)=xc(i)
      xzz(i)=xc(i)
      yc(4,i)=xnull
  697 continue
      endif
      if(ieigl.eq.1) then
      do 698 i=1,neigl
      dlig(i)=xnull
  698 continue
      endif
      if(iharm.eq.1) then
      do 699 i=1,n3
      yc(iconf,i)=xc(i)
      xzz(i)=xc(i)
      yc(4,i)=xnull
  699 continue
      endif
c start systematic search
      do 3001 ilau=1,ilauf
      ivmax=iblo(ilau,1)
      ihes=iblo(ilau,2)
      iori=iblo(ilau,3)
      itra=iblo(ilau,4)
      irez=iblo(ilau,5)
      ieigl=iblo(ilau,6)
      neigl=iblo(ilau,7)
      neigen=iblo(ilau,8)
      irst=iblo(ilau,9)
      rcut=blo(ilau,1)
      jb=3*iori+3*itra+irez*neigen
      ju=jb+ieigl*neigl
      jl=jb-3-irez*neigen
      jr=jb-irez*neigen
      if(irst.eq.1) call cacadis(disca)
c
c  start docking minimization
c
      call select
      call pairgen 
      call nonbon8
      if(ihes.eq.4) call harmonic
      if(ihes.eq.1) call steep(ivmax)
      if(ihes.eq.2) call minfor(ivmax)
      if(ihes.eq.4) call mincar(n3+n3l,ivmax,fnor)
c
c  output coordinates after each docking minimization run
c
      iligout=0
      if(iligout.eq.1) then
      write(filnam,177) ilau
  177 format('lig',i3.3,'.pdb')
      open(55,file=filnam)
      write(55,'(i5)') nlig
      do 485 i=1,nlig
      kk=3*(i-1)
      write(55,26)at,kai(i),tyi(i),rgi(i),iei(i),y(iconf,kk+1),
     1  y(iconf,kk+2),y(iconf,kk+3),iaci(i),xlai(i),icopl(i),wel(i+1)
  485 continue
      write(55,'(a3)')'TER'
      close(55)
      endif
 3001 continue
c
c re-check energy after all minimizations are done
c (this eliminates some complexes with overlap)
c
c     write(*,*)'before pairlist',gesa,enon+epote+eharm,enon,eharm,
c    1          epote,sqrt(fnor)
      erest=xnull
      erezp=xnull
      estat=xnull
      esolv=xnull
      enon=xnull
      call select
      call pairgen
      call nonbon8
      if(irst.eq.1) call disre
      if(irez.eq.1) call remin
      if(ihes.eq.4) then
        call harmonic
      fnor=xnull
      do 702 i=1,n3
      fnor=fnor+fc(i)**2
  702 continue
      do 704 i=1,n3l
      fnor=fnor+f(i)**2
  704 continue
      fnor=fnor/(n3+n3l)
      endif
      gesa=enon+epote+erest+erezp+enlig+eharm
c     write(*,*)'after pairlist',gesa,enon+eharm,enon,eharm,epote,
c    *                           sqrt(fnor)
c calculate norm of force
      dnorm=xnull
      do 705 i=1,ju
      dnorm=dnorm+delta(i)**2
  705 continue
      drest=xnull
      do 707 i=jr+1,ju
      drest=drest+delta(i)**2
  707 continue
      dnorm=sqrt(dnorm/ju)
      if(ihes.eq.4) dnorm=sqrt(fnor) 
c
c compare final placement with reference structure (only CA)
c
      xdi=xnull
      xdinter=xnull
      kinter=0
      do 845 i=1,nresl
      ii=3*(ialpl(i) - 1)
      jj=3*(ialpst(i) - 1)
      xdelt=(y(iconf,ii+1)-xzr(jj+1))**2+
     1        (y(iconf,ii+2)-xzr(jj+2))**2+
     2        (y(iconf,ii+3)-xzr(jj+3))**2
      xdi=xdi+xdelt
      do j=1,3
      ceend(j)=ceend(j)+y(iconf,ii+j)
      enddo
      do inter=1,nonp
      if(ialpl(i)-1.eq.nonl(inter)) then
      xdinter=xdinter+xdelt
      kinter=kinter+1
      endif
      enddo
  845 continue
      xdi=sqrt(xdi/nresl)
      xdinter=sqrt(xdinter/kinter)
      dice=xnull
      dste=xnull
      do j=1,3
      ceend(j)=ceend(j)/nresl
      enddo
      dste=dste+(ceend(1)-xrst)**2+(ceend(2)-yrst)**2+(ceend(3)-zrst)**2
      dste=sqrt(dste)
c
c check for native contacts
c
      rcut=49.0d0
      call pairgen
c create a pointer first
      k=0
      ik=1
      do i=1,nonp
        if(nonr(i).ne.k) then
         ipoint(ik)=i
         k=nonr(i)
         ik=ik+1
        endif
      enddo
      ipoint(ik)=nonp+1
      kold=0
      ncontact=0
      irecold=0
      iacc=1
      ialc=1
      nacr=0
      nalr=0
      do j=1,ncon
        irece=lisrec(j)
        if(irece.ne.irecold) then
         kold=kold+1
         irecold=irece
        endif
         iliga=lislig(j)
        do k=kold,ik-1
         if(irece.eq.nonr(ipoint(k))) then
           do i=ipoint(k),ipoint(k+1)-1
             if(nonr(i).eq.irece) then
               if(irece.gt.iacc) then
               iacc=irece
               nacr=nacr+1
               endif
             if(nonl(i).eq.iliga) then
c check if ligand atom was already counted
               ialc=0
               do jk=1,nalr
               if(iliga.eq.iill(jk)) ialc=1
               enddo
               if(ialc.eq.0) then
               nalr=nalr+1
               iill(nalr)=iliga
               endif
c  identical contact found
             ncontact=ncontact+1
             endif
             endif
           enddo
         endif
        enddo
       enddo
c
c output only, if converged & center of ligand not too far & energy okay
c
      if(dnorm.lt.1.0.and.xdi.lt.1000.0.and.gesa.lt.-1.0) then
c     if(dnorm.lt.0.01.and.xdi.lt.1000.0.and.gesa.lt.encut) then
      imodel=imodel+1
c
c  in case of isurf=1 calculate burried surface area of final complex
c
      if(isurf.eq.1) then
        do 627 i=1,natom
          ii=3*(i-1)
          xcrd(i)=yc(iconf,ii+1)
          ycrd(i)=yc(iconf,ii+2)
          zcrd(i)=yc(iconf,ii+3)
  627   continue
         call surface(xcrd,ycrd,zcrd,iac,radi,sasaf,snth,csth,
     1     cphgh,sphgh,srad,natom,ncosth,mphi,0)
        do 633 i=1,nlig
          ii=3*(i-1)
          xcrd(i)=y(iconf,ii+1)
          ycrd(i)=y(iconf,ii+2)
          zcrd(i)=y(iconf,ii+3)
  633   continue
         call surface(xcrd,ycrd,zcrd,iaci,radi,sasaf,snth,csth,
     1     cphgh,sphgh,srad,nlig,ncosth,mphi,natom)
          sasarec=xnull
          solvrec=xnull
            do 727 i=1,natom
             sasarec=sasarec+sasaf(i)
             solvrec=solvrec+solv(iac(i))*sasaf(i)
             ity(i)=iac(i)
             ii=3*(i-1)
             xcrd(i)=yc(iconf,ii+1)
             ycrd(i)=yc(iconf,ii+2)
             zcrd(i)=yc(iconf,ii+3)
  727       continue
          sasalig=xnull
          solvlig=xnull
            do 733 i=1,nlig
             sasalig=sasalig+sasaf(natom+i)
             solvlig=solvlig+solv(iaci(i))*sasaf(natom+i)
             ity(natom+i)=iaci(i)
             ii=3*(i-1)
             xcrd(natom+i)=y(iconf,ii+1)
             ycrd(natom+i)=y(iconf,ii+2)
             zcrd(natom+i)=y(iconf,ii+3)
  733       continue
          call surface(xcrd,ycrd,zcrd,ity,radi,sasa,snth,csth,
     1        cphgh,sphgh,srad,natom+nlig,ncosth,mphi,0)
          sasatot=xnull
          solvtot=xnull
            do 750 i=1,natom+nlig
             sasatot=sasatot+sasa(i)
             solvtot=solvtot+solv(ity(i))*sasa(i)
  750       continue
          sadf=sasatot-sasalig-sasarec
          sodf=solvtot-solvlig-solvrec
c
c  output all final results
c
      write(*,33) imodel,gesa,enon,epote,xdinter,dnorm,xdi,
     1  float(ncontact)/float(ncon),float(nacr)/float(natr),
     2  float(nalr)/float(natl),sadf,sodf,
     3  dmod(ssi,zwopi),dmod(phi,zwopi),dmod(rot,zwopi),
     4  xa,ya,za,(rez(k),k=1,5)
      write(13,33) imodel,gesa,enon,epote,xdinter,dnorm,xdi,
     1  float(ncontact)/float(ncon),float(nacr)/float(natr),
     2  float(nalr)/float(natl),sadf,sodf,
     3  dmod(ssi,zwopi),dmod(phi,zwopi),dmod(rot,zwopi),
     4  xa,ya,za,(rez(k),k=1,5)
      else
      write(*,29) imodel,gesa,enon,epote,xdinter,dnorm,xdi,
     1   float(ncontact)/float(ncon),float(nacr)/float(natr),
     2   float(nalr)/float(natl),dmod(ssi,zwopi),dmod(phi,zwopi),
     3   dmod(rot,zwopi),xa,ya,za,(rez(k),k=1,5)
      write(13,29) imodel,gesa,enon,epote,xdinter,dnorm,xdi,
     1   float(ncontact)/float(ncon),float(nacr)/float(natr),
     2   float(nalr)/float(natl),dmod(ssi,zwopi),dmod(phi,zwopi),
     3   dmod(rot,zwopi),xa,ya,za,(rez(k),k=1,5)
      endif
c
c  open  and output final ligand protein structure after all minimizations
c
c  supress the coordinate output
      goto 640 
      jj=0
        do 900 i=1,nlig
        if(iacl(i).eq.1) then
        jj=jj+1
         kk=3*(i-1)
         write(*,23)at,jj,tyi(i),rgi(i),"A",iei(i),y(iconf,kk+1),
     1   y(iconf,kk+2),y(iconf,kk+3),iaci(i),xlai(i),icopl(i),wel(i)
        endif
  900   continue
c
c  output receptor structure if irez=1 (flexible receptor)
c
       if(irez.eq.1) then
        write(*,'(a3)')'TER'
        do 910 i=1,natom
         if(iacr(i).eq.1) then
           kk=3*(i-1)
           write(*,23) at,ka(i),ty(i),rg(i),"B",ie(i),yc(iconf,kk+1),
     1     yc(iconf,kk+2),yc(iconf,kk+3),iac(i),xla(i),icopr(i),wer(i)
         endif
  910   continue
       endif
      write(*,'(a3)')'TER'
      write(*,'(a3)')'END'
      endif
  640 continue
  620 continue
  600 continue
  597 continue
      close(12)
      close(13)
   17 format(a4,2f7.3,i3)
   20 format(a80)
   23 format(a4,i7,2x,a4,a4,a1,i4,4x,3f8.3,i5,f8.3,i2,f5.2)
   24 format(a4,i7,2x,a4,a4,1x,i4,4x,3f8.3)
   26 format(a4,i7,2x,a4,a4,1x,i4,4x,3f8.3,i5,f8.3,i2,f5.2)
   27 format(a12,3f12.4)
   28 format(a7,i5,a7,f13.4,a8,f13.4,a7,f13.4)
   29 format(i6,f9.3,f8.2,f6.1,f7.2,e8.1,f7.2,3f6.3,3f7.3,3f7.2,5f6.1)
   33 format
     1 (i6,f9.3,f8.2,f6.1,f7.2,e8.1,f7.2,3f6.3,2f10.3,3f7.3,3f7.2,5f6.1)
   31 format(30x,3f8.3)
 3002 end
