      program collect
c
c  program to reduce the output file from a systematic docking search
c  such that every docking minimum is reported only once
c  usage: $path/collect ligand.pdb out.dat receptor.pdb
c  author: Martin Zacharias, Jacobs University Bremen
c
      implicit real*8 (a-h,o-z)
      implicit integer*4 (i-n)
      character*80 b,name1,name2,name3,name4
      character*4 ty(8000),rg(8000),tr(8000),rr(8000),at
      dimension x(25000),xol(25000),wel(8000),xla(8000),
     1  tot(90000),vdw(90000),est(90000),erz(90000),
     2  rms(90000),cen(90000),fna(90000),frz(90000),
     3  fli(90000),ssi(90000),phi(90000),rot(90000),
     4  trx(90000),try(90000),trz(90000),ce(3),xc(25000),
     5  xlc(8000),welc(8000),eig(10,25000),val(10),rez(90000,5)
      dimension ka(8000),ie(8000),icop(8000),iac(8000),
     1          num(90000),iuni(60000),nuni(60000),
     2          kr(8000),ir(8000),ic(8000),icopc(8000)
      call getarg(1,name1)
      call getarg(2,name2)
      call getarg(3,name3)
      call getarg(4,name4)
      read(name4,*) irez
      write(*,*)'irez',irez
      kfi=index(name2,' ')-5
      i=1
      ce(1)=0.0d0
      ce(2)=0.0d0
      ce(3)=0.0d0
      open(49,file=name1)
   30 read(49,20,end=40) b 
      if(b(:4).eq.'ATOM') then
      ii=3*(i-1)
      read(b,26) at,ka(i),ty(i),rg(i),ie(i),xol(ii+1),
     1 xol(ii+2),xol(ii+3),iac(i),xla(i),icop(i),wel(i)
c     write(*,26) at,ka(i),ty(i),rg(i),ie(i),xol(ii+1),
c    1 xol(ii+2),xol(ii+3),iac(i),xla(i),icop(i),wel(i)
      ce(1)=ce(1)+xol(ii+1)
      ce(2)=ce(2)+xol(ii+2)
      ce(3)=ce(3)+xol(ii+3)
      i=i+1
      endif
      goto 30 
   40 close(49)
      nlig=i-1
      n3l=3*nlig
      do 50 i=1,3
      ce(i)=ce(i)/nlig
      write(*,*)'ce',ce(i)
   50 continue
      do 60 i=1,nlig
      ii=3*(i-1)
      do 70 j=1,3
      xol(ii+j)=xol(ii+j)-ce(j)
   70 continue
   60 continue
      i=1
      open(51,file=name2)
   75 read(51,29,end=100)num(i),tot(i),vdw(i),est(i),erz(i),conv,rms(i),
     1 fna(i),frz(i),fli(i),ssi(i),phi(i),rot(i),trx(i),try(i),
     2 trz(i),rez(i,1),rez(i,2),rez(i,3),rez(i,4),rez(i,5)
      i=i+1
      goto 75
  100 close(51)
      ntot=i-1
      write(*,*)'ntot',ntot
c
      i=1
      open(51,file=name3)
  130 read(51,20,end=140) b 
      if(b(:4).eq.'ATOM') then
      ii=3*(i-1)
      read(b,26) at,kr(i),tr(i),rr(i),ir(i),xc(ii+1),
     1 xc(ii+2),xc(ii+3),ic(i),xlc(i),icopc(i),welc(i)
      i=i+1
      endif
      goto 130 
  140 close(51)
      natom=i-1
      n3=3*natom
      do 145 i=1,n3
      do 147 l=1,5
      eig(l,i)=0.0d0
  147 continue
  145 continue
      write(*,*)'natom',natom,n3
      if(irez.eq.1) then
      itest=int(n3/6)
      irest=n3-6*itest
      open(12,file='hm.dat')
      do 150 l=1,5
      read(12,*) kk,val(l)
      do 160 i=1,itest
      read(12,*)(eig(l,6*(i-1)+j),j=1,6)
  160 continue
      if(irest.gt.0) read(12,*)(eig(l,6*itest+j),j=1,irest)
      write(*,*) 'eigenvector read ',l,kk,val(l)
  150 continue
      close(12)
c     write(*,*) ' check norm and orthogonality of eigenvectors'
      do 162 l=1,5
      eigval=xnull
      do 165 j=1,n3
      eigval=eigval+eig(l,j)*eig(l,j)
  165 continue
c     write(*,*) 'Norm of eigenvector ', l, eigval
      eigval=1.0d0/dsqrt(eigval)
      do 166 j=1,n3
      eig(l,j)=eigval*eig(l,j)
  166 continue
      eigval=0.0d0
      do 167 k=1,l
      do 168 j=1,n3
      eigval=eigval+eig(l,j)*eig(k,j)
  168 continue
c     write(*,*) 'Orthogonality of eigenvectors ', l,k,eigval
  167 continue
  162 continue
      endif
c
c  start to reduce the number of unique complexes
      pi=3.141592654d0
      zpi=2.0d0*pi
      sma=0.01d0
      do 200 i=1,ntot
      do 220 j=1,i-1
c check for equivalent orientation
      if((ssi(i)-ssi(j))**2.lt.sma.or.(ssi(i)-ssi(j)+zpi)**2.lt.sma
     1 .or.(ssi(i)-ssi(j)-zpi)**2.lt.sma) then
      if((phi(i)-phi(j))**2.lt.sma.or.(phi(i)-phi(j)+zpi)**2.lt.sma
     1 .or.(phi(i)-phi(j)-zpi)**2.lt.sma) then
      if((rot(i)-rot(j))**2.lt.sma.or.(rot(i)-rot(j)+zpi)**2.lt.sma
     1 .or.(rot(i)-rot(j)-zpi)**2.lt.sma) then
      ssi(i)=ssi(j)
      phi(i)=phi(j)
      rot(i)=rot(j)
      endif
      endif
      endif
      if((-ssi(i)-ssi(j))**2.lt.sma.or.(-ssi(i)-ssi(j)+zpi)**2.lt.sma
     1 .or.(-ssi(i)-ssi(j)-zpi)**2.lt.sma) then
      if((phi(i)-phi(j)+pi)**2.lt.sma.or.(phi(i)-phi(j)-pi)**2.lt.sma)
     1 then 
      if((rot(i)-rot(j)+pi)**2.lt.sma.or.(rot(i)-rot(j)-pi)**2.lt.sma)
     1 then 
      ssi(i)=ssi(j)
      phi(i)=phi(j)
      rot(i)=rot(j) 
      endif
      endif
      endif
  220 continue
  200 continue
c check for unique translation and rotation
      sma=0.2
      iu=1
      iuni(1)=1
      do 300 i=1,ntot
      nuni(i)=1
      do 320 j=1,iu
      k=iuni(j)
      if((trx(i)-trx(k))**2.lt.sma.and.(try(i)-try(k))**2.lt.sma
     1 .and.(trz(i)-trz(k))**2.lt.sma.and.(ssi(i)-ssi(k))**2.lt.sma
     2 .and.(phi(i)-phi(k))**2.lt.sma.and.(rot(i)-rot(k))**2.lt.sma)
     3 then
        nuni(j)=nuni(j)+1
        goto 300
       endif
  320 continue
      iu=iu+1
      iuni(iu)=i
  300 continue
      open(42,file=name2(:kfi)//'.red')
      open(43,file=name2(:kfi)//'.tra')
      write(*,*)'number of unique complexes',iu
      do 400 k=1,iu
      i=iuni(k)
c     write(42,31) num(i),tot(i),vdw(i),est(i),erz(i),conv,rms(i),
c    1 fna(i),frz(i),fli(i),ssi(i),phi(i),rot(i),trx(i),try(i),
c    2 trz(i),nuni(k)
      write(42,31) k,tot(i),vdw(i),est(i),erz(i),conv,rms(i),
     1 fna(i),frz(i),fli(i),ssi(i),phi(i),rot(i),trx(i),try(i),
     2 trz(i),nuni(k)
      write(43,24)'ATOM',i,"CA  ","TRA ",i,trx(i),try(i),trz(i),0,
     1            float(nuni(k))
c     write(*,31) num(i),tot(i),vdw(i),est(i),erz(i),conv,rms(i),
c    1 fna(i),frz(i),fli(i),ssi(i),phi(i),rot(i),trx(i),try(i),
c    2 trz(i),nuni(k)
      write(*,31) k,tot(i),vdw(i),est(i),erz(i),conv,rms(i),
     1 fna(i),frz(i),fli(i),ssi(i),phi(i),rot(i),trx(i),try(i),
     2 trz(i),nuni(k)
      if(irez.ge.0) then
      call anfang(x,xol,ssi(i),phi(i),rot(i),nlig)
      do 450 j=1,nlig
      ii=3*(j-1)
      write(*,27) at,ka(j),ty(j),rg(j),"A",ie(j),x(ii+1)+trx(i),
     1 x(ii+2)+try(i),x(ii+3)+trz(i),iac(j),xla(j),icop(j),wel(j)
  450 continue
      write(*,'(a3)') 'TER'
      do 460 j=1,natom
      ii=3*(j-1)
      xrz=xc(ii+1)
      yrz=xc(ii+2)
      zrz=xc(ii+3)
      do 470 m=1,5
      xrz=xrz+rez(i,m)*eig(m,ii+1) 
      yrz=yrz+rez(i,m)*eig(m,ii+2) 
      zrz=zrz+rez(i,m)*eig(m,ii+3) 
  470 continue
      write(*,27) at,kr(j),tr(j),rr(j),"B",ir(j),xrz,
     1 yrz,zrz,ic(j),xlc(j),icopc(j),welc(j)
  460 continue
      write(*,'(a3)') 'TER'
      write(*,'(a3)') 'END'
      endif
  400 continue 
      close(42)
      close(43)
c
   20 format(a80)
   24 format(a4,i7,2x,a4,a4,1x,i4,4x,3f8.3,i5,f8.3) 
   26 format(a4,i7,2x,a4,a4,1x,i4,4x,3f8.3,i5,f8.3,i2,f5.2) 
   27 format(a4,i7,2x,a4,a4,a1,i4,4x,3f8.3,i5,f8.3,i2,f5.2) 
   29 format(i6,f9.3,f8.2,f6.1,f7.2,e8.1,f7.2,3f6.3,3f7.3,3f7.2,5f6.1)
   31 format(i6,f9.3,f8.2,2f6.1,e8.1,f7.2,3f6.3,3f7.3,3f7.2,i3)
      end
c 
      subroutine anfang(x,xol,ssii,phii,roti,nlig)
c this subroutine rotates the ligand protein in Euler angles ssii,phii,roti
      implicit real*8 (a-h,o-z)
      implicit integer*4 (i-n)
      integer nlig
      dimension x(3*nlig),xol(3*nlig)
      cs=cos(ssii)
      cp=cos(phii)
      ss=sin(ssii)
      sp=sin(phii)
      cscp=cs*cp
      cssp=cs*sp
      sscp=ss*cp
      sssp=ss*sp
      crot=cos(roti)
      srot=sin(roti)
      do 60 i=1,nlig
      ii=3*(i-1)
      xar=xol(ii+1)*crot+xol(ii+2)*srot
      yar=-xol(ii+1)*srot+xol(ii+2)*crot
      x(ii+1)=xar*cscp-yar*sp+xol(ii+3)*sscp
      x(ii+2)=xar*cssp+yar*cp+xol(ii+3)*sssp
      x(ii+3)=-xar*ss+xol(ii+3)*cs
   60 continue
      return
      end    
