      subroutine mincar(ntot3,maxfun,fnor)
c  variable metric minimizer (Harwell subroutine lib. same as in Jumna with modifications)
      include "CADD.t"
      dimension h((ntot3*(ntot3+1))/2)
      dimension g(ntot3),d(ntot3),w(ntot3),xaa(ntot3),ga(ntot3),
     1 gb(ntot3),xcc(ntot3),xbb(ntot3),xtot(ntot3),ftot(ntot3)
      nfun=0
      itr=0
      ntot=nlig+natom
      np=ntot3+1
      acc=0.000000001D0
c     set the hessian to a diagonal matrix 
      c=xnull
      do 30 i=1,ntot3
30    c=max(c,abs(g(i)))
      if (c.le.xnull) c=1.0D0
      k=(ntot3*np)/2
      do 40 i=1,k
40    h(i)=xnull
      k=1
      do 50 i=1,ntot3
      h(k)=0.01d0*c
      k=k+np-i
50    continue
c     set some variables for the first iteration
      dff=xnull
      iab=1
      enon=xnull
      epote=xnull
c     write(*,*)'ntot3',n3,n3l,ntot3,xnull
c  combine receptor and ligand into one structure array and one force array
c  we need to minimize Cartesian positions of all atoms
      do 60 i=1,n3
      xtot(i)=yc(iconf,i)
60    continue
      do 65 i=1,n3l
      xtot(n3+i)=y(iconf,i)
65    continue 
      iab=1
      call nonbon8
      call harmonic
c combine force array
      do 70 i=1,n3
      ftot(i)=fc(i)
70    continue
      do 75 i=1,n3l
      ftot(n3+i)=f(i)
75    continue
c add enm-term for each atom
c   
      gesa=enon+epote+eharm
c     write(*,*)'start gesa enon eharm',gesa,enon,epote,eharm
110   fa=gesa
      isfv=1
c store forces and coordinates
      do 120 i=1,ntot3
      g(i)=-ftot(i)
      xaa(i)=xtot(i)
      xnor=xnor+ftot(i)**2
120   ga(i)=g(i)
c     begin the iteration by giving the required printing
135   itr=itr+1
c     calculate the search direction of the iteration
      do 150 i=1,ntot3
150   d(i)=-ga(i)
      call mc11e (h,ntot3,d,w,ntot3)
c     calculate a lower bound on the step-length
c     and the initial directional derivative
      c=xnull
      dga=xnull
      do 160 i=1,ntot3
      c=max(c,abs(d(i)))
160   dga=dga+ga(i)*d(i)
c     test if the search direction is downhill
      if (dga.ge.xnull) go to 240
c     set the initial step-length of the line search
      stmin=xnull
      stepbd=xnull
      steplb=acc/c
      fmin=fa
      gmin=dga
      step=1.0d0
      if (dff.le.xnull) step=min(step,1.0d0/c)
      if (dff.gt.xnull) step=min(step,(dff+dff)/(-dga))
170   c=stmin+step
c     test whether func has been called maxfun times
c     write(*,*)'here we are'
      if (nfun.ge.maxfun) go to 250
      nfun=nfun+1
c     calculate another function value and gradient
      do 172 i=1,ntot3
      xcc(i)=xtot(i)
      xtot(i)=xaa(i)+c*d(i)
172   g(i)=-ftot(i)
c need to split coordinates again
      do 175 i=1,n3
      yc(iconf,i)=xtot(i)
175   continue
      do 177 i=1,n3l
177   y(iconf,i)=xtot(n3+i)
      call nonbon8
      call harmonic
      do 180 i=1,n3
      ftot(i)=fc(i)
180   continue
      do 182 i=1,n3l
      ftot(n3+i)=f(i)
182   continue
c add enm-term for each atom
c
      fb=enon+epote+eharm
c     write(*,*)'step fb,enon,eharm',iter,fb,enon,epote,eharm
      fnor=xnull
      do 185 i=1,ntot3
      xbb(i)=xtot(i)
      gb(i)=-ftot(i)
      fnor=fnor+gb(i)**2
  185 continue
      fnor=fnor/ntot3
c     write(*,*)'fnor',fnor,fc(2007),ftot(2007)
c     store this function value if it is the smallest so far
      isfv=min(2,isfv)
      if (fb.gt.gesa) go to 220
      if (fb.lt.gesa) go to 200
      gl1=xnull
      gl2=xnull
      do 192 i=1,ntot3
      gl1=gl1+(g(i))**2
192   gl2=gl2+(gb(i))**2
      if (gl2.ge.gl1) go to 220
200   isfv=3
      gesa=fb
      do 210 i=1,ntot3
      xtot(i)=xbb(i)
210   g(i)=gb(i)
c need to split coordinates again
c     write(*,*)'reached split'
      do 218 i=1,n3
      yc(iconf,i)=xtot(i)
218   continue
      do 225 i=1,n3l
225   y(iconf,i)=xtot(n3+i)
c     calculate the directional derivative at the new point
220   dgb=xnull
      do 230 i=1,ntot3
230   dgb=dgb+gb(i)*d(i)
c     branch if we have found a new lower bound on the step-length
      if (fb-fa.le.0.1d0*c*dga) go to 280
c     finish the iteration if the current step is steplb
      if (step.gt.steplb) go to 270
240   if (isfv.ge.2) go to 110
c     at this stage the whole calculation is complete
250   if(nfun.lt.maxfun) then
      nfun=nfun+1
      do 255 i=1,n3
      yc(iconf,i)=xtot(i)
255   continue
      do 257 i=1,n3l
257   y(iconf,i)=xtot(n3+i)
      call nonbon8
      call harmonic
      do 260 i=1,n3
      ftot(i)=fc(i)
260   continue
      do 262 i=1,n3l
      ftot(n3+i)=f(i)
262   continue
c
      gesa=enon+epote+eharm
      fnor=xnull
      do 265 i=1,ntot3
      fnor=fnor+ftot(i)**2
265   g(i)=ftot(i)
      fnor=fnor/ntot3
c     write(*,*)'fnor final',fnor
      endif
      if(gesa.lt.fb) then
      do 267 i=1,n3
      yc(iconf,i)=xcc(i)
267   continue
      do 269 i=1,n3l
269   y(iconf,i)=xcc(n3+i)
      else
      gesa=fb
      endif
      return
c     calculate a new step-length by cubic interpolation
270   stepbd=step
c     write(*,*)'reached end'
      c=gmin+dgb-3.0d0*(fb-fmin)/step
      c=gmin/(c+gmin-sqrt(c*c-gmin*dgb))
      step=step*max(0.1d0,c)
      go to 170
c     set the new bounds on the step-length
280   stepbd=stepbd-step
      stmin=c
      fmin=fb
      gesa=fb
      gmin=dgb
c     calculate a new step-length by extrapolation
      step=9.0d0*stmin
      if (stepbd.gt.xnull) step=0.5d0*stepbd
      c=dga+3.0d0*dgb-4.0d0*(fb-fa)/stmin
      if (c.gt.xnull) step=min(step,stmin*max(1.0d0,-dgb/c))
      if (dgb.lt.0.7d0*dga) go to 170
c     test for convergence of the iterations
      isfv=4-isfv
      if (stmin+step.le.steplb) go to 240
c     revise the second derivative matrix
      ir=-ntot3
      do 290 i=1,ntot3
      xaa(i)=xbb(i)
      xbb(i)=ga(i)
      d(i)=gb(i)-ga(i)
290   ga(i)=gb(i)
      call mc11a(h,ntot3,xbb,1.0d0/dga,w,ir,1,xnull)
      ir=-ir
      call mc11a (h,ntot3,d,1.0d0/(stmin*(dgb-dga)),d,ir,0,xnull)
c     branch if the rank of the new matrix is deficient
      if (ir.lt.ntot3) go to 250
c     begin another iteration
      ntot3dff=fa-fb
      fa=fb
      go to 135
111   format(a20,i5,f18.8)
112   format(a20,i5,2f18.8)
113   format(a4,i7,10x,i5,4x,3f8.3,i5,f8.3,i2) 
      end
