      subroutine minfor(maxfun)
c  variable metric minimizer (Harwell subroutine lib. same as in Jumna with modifications)
      include "CADD.t"
      dimension h(5000)
      dimension g(50),d(50),w(50),xaa(50),rezo(50),rezn(50),
     1 ga(50),xbb(50),gb(50),cartaa(15000),cartbb(15000),xrot(15000),
     2 cartac(15000),cartbc(15000),cartad(15000),cartbd(15000),
     3 cartacl(15000),cartadl(15000),cartbcl(15000),cartbdl(15000)
      nfun=0
      itr=0
      np=ju+1
      acc=0.000000001D0
c     set the hessian to a diagonal matrix 
      c=xnull
      if (c.le.xnull) c=1.0D0
      k=(ju*np)/2
      do 40 i=1,k
40    h(i)=xnull
      k=1
      do 50 i=1,ju
      h(k)=0.01d0*c
50    k=k+np-i
c     set some variables for the first iteration
      dff=xnull
      iab=1
      erest=xnull
      erezp=xnull
      epote=xnull
      esolv=xnull
      enon=xnull
      enlig=xnull
      do 60 j=1,n3l
      y(5,j)=xnull
   60 continue
 1000 call select
      call pairgen
      call nonbon8
      if(irst.eq.1) call disre
      if(irez.eq.1) call remin
      if(ieigl.eq.1) call ligmin
      if(iori.eq.1) call rota
      if(itra.eq.1) call trans
      gesa=enon+epote+erest+esolv+erezp+enlig
c     write(*,*)'start en jl,jr,jb,ju',np,gesa,jl,jr,jb,ju
110   fa=gesa
c     write(*,*)'restart',nfun,iter
      isfv=1
c store forces, Euler angle, position and ligand and receptor coordinates
      do 120 i=1,ju
      g(i)=-delta(i)
120   ga(i)=g(i)
      if(iori.eq.1) then 
      xaa(1)=phi
      xaa(2)=ssi
      xaa(3)=rot
      endif
      if(itra.eq.1) then
      xaa(jl+1)=xa
      xaa(jl+2)=ya
      xaa(jl+3)=za
      endif
      do 125 i=1,n3l
      cartaa(i)=y(iconf,i)
      xrot(i)=x(i)
125   continue
c if receptor flex is included store initial coordinates in cartac(i) and
c accumulated (up to current minimization) deformation in cartad(i)
c store deformation factor in every mode in rezo(j)
      if(irez.eq.1) then
      do 126 i=1,n3
      cartac(i)=yc(iconf,i)
      cartad(i)=yc(4,i)
 126  continue
      do 127 i=1,neigen
      xaa(jr+i)=rez(i)
 127  continue
      endif
c if ligand flex is included store initial coordinates in cartacl(i) and
c accumulated (up to current minimization) deformation in cartadl(i)
c store deformation factor in every mode in dlig(j)
      if(ieigl.eq.1) then
      do 128 i=1,n3l
      cartacl(i)=y(iconf,i)
      cartadl(i)=y(4,i)
      do 129 j=1,neigl 
      eigrot(j,i)=eigl(j,i)
 129  continue
 128  continue
      do 131 i=1,neigl
      xaa(jb+i)=dlig(i)
 131  continue
      endif
      
c     begin the iteration by giving the required printing
135   itr=itr+1
c     calculate the search direction of the iteration
      do 150 i=1,ju
150   d(i)=-ga(i)
      call mc11e (h,ju,d,w,ju)
c     calculate a lower bound on the step-length
c     and the initial directional derivative
      c=xnull
      dga=xnull
      do 160 i=1,ju
      c=max(c,abs(d(i)))
160   dga=dga+ga(i)*d(i)
c     test if the search direction is downhill
      if (dga.ge.xnull) go to 240
c     set the initial step-length of the line search
      stmin=xnull
      stepbd=xnull
      steplb=acc/c
      fmin=fa
      gmin=dga
      step=1.0d0
      if (dff.le.xnull) step=min(step,1.0d0/c)
      if (dff.gt.xnull) step=min(step,(dff+dff)/(-dga))
170   c=stmin+step
c     test whether func has been called maxfun times
      if (nfun.ge.maxfun) go to 250
      nfun=nfun+1
c     calculate another function value and gradient
      do 180 i=1,ju
180   g(i)=-delta(i)
c make an Euler rotation
      if(iori.eq.1) then
         phi=xaa(1)+c*d(1)
         ssi=xaa(2)+c*d(2)
         rot=xaa(3)+c*d(3)
         cs=cos(ssi)
         cp=cos(phi)
         ss=sin(ssi)
         sp=sin(phi)
         cscp=cs*cp
         cssp=cs*sp
         sscp=ss*cp
         sssp=ss*sp
         crot=cos(rot)
         srot=sin(rot)
         do 1060 i=1,nlig
         ii=3*(i-1)
         xar=xb(ii+1)*crot+xb(ii+2)*srot
         yar=-xb(ii+1)*srot+xb(ii+2)*crot
         x(ii+1)=xar*cscp-yar*sp+xb(ii+3)*sscp
         x(ii+2)=xar*cssp+yar*cp+xb(ii+3)*sssp
         x(ii+3)=-xar*ss+xb(ii+3)*cs
         xrot(ii+1)=x(ii+1)
         xrot(ii+2)=x(ii+2)
         xrot(ii+3)=x(ii+3)
 1060 continue
        if(ieigl.eq.1) then
         do 1070 j=1,neigl
            do 1080 i=1,nlig
               ii=3*(i-1)
               xar=eigl(j,ii+1)*crot+eigl(j,ii+2)*srot
               yar=-eigl(j,ii+1)*srot+eigl(j,ii+2)*crot
               eigrot(j,ii+1)=xar*cscp-yar*sp+eigl(j,ii+3)*sscp
               eigrot(j,ii+2)=xar*cssp+yar*cp+eigl(j,ii+3)*sssp
               eigrot(j,ii+3)=-xar*ss+eigl(j,ii+3)*cs
 1080       continue
 1070    continue
        endif 
      endif
c make a move in HM direction and update x, y(iconf,i) and y(4,i) and dlig(j)
      if(ieigl.eq.1) then
      do 1150 j=1,n3l
      y(5,j)=xnull
 1150 continue
      do 1200 i=1,neigl
c     write(*,'(a20,i3,5f13.6)') 'i,xaa,dlig,delta,d,c',
c    1 i,xaa(i+jb),dlig(i),delta(i+jb),d(i+jb),c
      dlig(i)=xaa(i+jb)-d(i+jb)*c
c y(5,j) contains now the accumulated deformation (including previous deforms) in mode j
      do 1210 j=1,n3l
      y(5,j)=y(5,j)+eigrot(i,j)*dlig(i)
 1210 continue
 1200 continue
      endif
c make a translation of the ligand center
      if(itra.eq.1) then
      xa=xaa(jl+1)+c*d(jl+1)
      ya=xaa(jl+2)+c*d(jl+2)
      za=xaa(jl+3)+c*d(jl+3)
      endif
c update cartesian ligand coordinates
      do 1004 i=1,nlig
      jj=3*(i-1)
      y(iconf,jj+1)=xa+x(jj+1)+y(5,jj+1)
      y(iconf,jj+2)=ya+x(jj+2)+y(5,jj+2)
      y(iconf,jj+3)=za+x(jj+3)+y(5,jj+3)
 1004 continue
c
c make a move in HM direction and update yc(iconf,i) and yc(4,i) and rez(j)
      if(irez.eq.1) then
      do 1050 j=1,n3
      yc(5,j)=xnull
 1050 continue
      do 1100 i=1,neigen
c     write(*,*) 'del',d(i+jr),c
      rez(i)=xaa(i+jr)-d(i+jr)*c
      do 1110 j=1,n3
      yc(5,j)=yc(5,j)-eig(i,j)*d(i+jr)*c
 1110 continue
 1100 continue
      do 1120 j=1,n3
      yc(iconf,j)=xzz(j)+cartad(j)+yc(5,j)
 1120 continue
      endif
      call nonbon8
      if(irst.eq.1) call disre
      if(irez.eq.1) call remin
      if(ieigl.eq.1) call ligmin
      fb=enon+epote+erest+esolv+erezp+enlig
      if(iori.eq.1) call rota
      if(itra.eq.1) call trans
c     write(*,112)'energy after move',nfun,fb,gesa
      do 185 i=1,ju
185   gb(i)=-delta(i)
      if(iori.eq.1) then
      xbb(1)=phi
      xbb(2)=ssi
      xbb(3)=rot
      endif
      if(itra.eq.1) then
      xbb(jl+1)=xa
      xbb(jl+2)=ya
      xbb(jl+3)=za
      endif
      do 187 i=1,n3l
      cartbb(i)=y(iconf,i)
187   continue
c store new receptor coordinates (after step c has been done) and accumulated 
c defomation in cartbc and cartbd 
      if(irez.eq.1) then
      do 188 i=1,n3
      cartbc(i)=yc(iconf,i)
      cartbd(i)=yc(iconf,i)-xzz(i)
      yc(4,i)=cartbd(i)
188   continue
      do 189 i=1,neigen
      xbb(i+jr)=rez(i)
189   continue
      endif
c
c store new ligand coordinates (after step c has been done) and accumulated 
c defomation in cartbcl and cartbdl 
      if(ieigl.eq.1) then
      do 190 i=1,n3l
      cartbcl(i)=y(iconf,i)
      cartbdl(i)=x(i)-xrot(i)
      y(4,i)=cartbdl(i)
 190  continue
      do 191 i=1,neigl
      xbb(i+jb)=dlig(i)
 191  continue
      endif
c
c     store this function value if it is the smallest so far
      isfv=min(2,isfv)
      if (fb.gt.gesa) go to 220
      if (fb.lt.gesa) go to 200
      gl1=xnull
      gl2=xnull
      do 192 i=1,ju
      gl1=gl1+(g(i))**2
 192  gl2=gl2+(gb(i))**2
      if (gl2.ge.gl1) go to 220
200   isfv=3
      gesa=fb
      do 210 i=1,ju
210   g(i)=gb(i)
      if(iori.eq.1) then
      phi=xbb(1)
      ssi=xbb(2)
      rot=xbb(3)
      endif
      if(itra.eq.1) then
      xa=xbb(jl+1)
      ya=xbb(jl+2)
      za=xbb(jl+3)
      endif 
c  irrelevant whether mode movement is involved or not
      do 215 i=1,n3l
      y(iconf,i)=cartbb(i)
215   continue
      if(irez.eq.1) then
      do 216 i=1,n3
      yc(iconf,i)=cartbc(i)
      yc(4,i)=cartbd(i)
 216  continue 
      do 217 i=1,neigen
      rez(i)=xbb(i+jr)
 217  continue
      endif
      if(ieigl.eq.1) then
c     do 218 i=1,n3l
c      y(iconf,i)=cartbcl(i)     
c account for trans rot an mode movement here 
c     y(4,i)=cartbdl(i)
c218  continue 
      do 219 i=1,neigl
      dlig(i)=xbb(i+jb)
219   continue
      endif
c     calculate the directional derivative at the new point
220   dgb=xnull
      do 230 i=1,ju
230   dgb=dgb+gb(i)*d(i)
c     branch if we have found a new lower bound on the step-length
      if (fb-fa.le.0.1d0*c*dga) go to 280
c     finish the iteration if the current step is steplb
      if (step.gt.steplb) go to 270
240   if (isfv.ge.2) go to 110
c     at this stage the whole calculation is complete
250   if(nfun.lt.maxfun) then
      nfun=nfun+1
      call nonbon8
      if(irst.eq.1) call disre
      if(irez.eq.1) call remin
      if(ieigl.eq.1) call ligmin
      gesa=enon+epote+erest+esolv+erezp+enlig
      if(iori.eq.1) call rota
      if(itra.eq.1) call trans
c     write(*,111)'energy after update',nfun,gesa
c     write(*,*)(delta(i),i=1,ju)
      do 255 i=1,ju
255   g(i)=-delta(i)
      endif
      return
c     calculate a new step-length by cubic interpolation
c     write(*,*)'try a new step length'
270   stepbd=step
      c=gmin+dgb-3.0d0*(fb-fmin)/step
      c=gmin/(c+gmin-sqrt(c*c-gmin*dgb))
      step=step*max(0.1d0,c)
      go to 170
c     set the new bounds on the step-length
280   stepbd=stepbd-step
      stmin=c
      fmin=fb
      gmin=dgb
c     calculate a new step-length by extrapolation
      step=9.0d0*stmin
      if (stepbd.gt.xnull) step=0.5d0*stepbd
      c=dga+3.0d0*dgb-4.0d0*(fb-fa)/stmin
      if (c.gt.xnull) step=min(step,stmin*max(1.0d0,-dgb/c))
      if (dgb.lt.0.7d0*dga) go to 170
c     test for convergence of the iterations
      isfv=4-isfv
      if (stmin+step.le.steplb) go to 240
c     revise the second derivative matrix
      ir=-ju
      do 290 i=1,ju
      xaa(i)=xbb(i)
      xbb(i)=ga(i)
      d(i)=gb(i)-ga(i)
290   ga(i)=gb(i)
      do 295 i=1,n3l
      cartaa(i)=cartbb(i)
295   continue
      if(irez.eq.1) then
      do 300 i=1,n3
      cartac(i)=cartbc(i)
      cartad(i)=cartbd(i)
300   continue
      endif
      if(ieigl.eq.1) then
      do 301 i=1,n3l
      cartacl(i)=cartbcl(i)
      cartadl(i)=cartbdl(i)
 301  continue
      endif
      call mc11a(h,ju,xbb,1.0d0/dga,w,ir,1,xnull)
      ir=-ir
      call mc11a (h,ju,d,1./(stmin*(dgb-dga)),d,ir,0,xnull)
c     branch if the rank of the new matrix is deficient
      if (ir.lt.ju) go to 250
c     begin another iteration
      dff=fa-fb
      fa=fb
      go to 135
111   format(a20,i5,f18.8)
112   format(a20,i5,2f18.8)
113   format(a4,i7,10x,i5,4x,3f8.3,i5,f8.3,i2) 
      end
