      subroutine rota
      include "CADD.t"
c
c     calculates orientational force contributions
c     component 1: phi-angle
c     component 2: ssi-angle
c     component 3: rot-angle
c this subroutine requires the partial derivative of Cartesians with respect to the 
c Euler variables (in pm(,) array),in case of ligand flex it is necessary to use the
c deformed ligand (in the orginal orientation, for ssi=0 etc.) to calculate the pm() array
c pm() arry depends on both the current Euler angles and the Cartesians in the orginal 
c orientation  
      
      do 5 k=1,3
      delta(k)=0.0d0
      do 6 j=1,3
      pm(k,j)=0.0d0
    6 continue
    5 continue
      cs=cos(ssi)
      cp=cos(phi)
      ss=sin(ssi)
      sp=sin(phi)
      cscp=cs*cp
      cssp=cs*sp
      sscp=ss*cp
      sssp=ss*sp
      crot=cos(rot)
      srot=sin(rot)
      do 10 i=1,nlig
      ii=3*(i-1)
      if(ieigl.eq.1) then
      xxx=xnull
      yyy=xnull
      zzz=xnull
c add up all eihenvector deformations stored in dlig()
      do 15 j=1,neigl
      xxx=xxx+dlig(j)*eigl(j,ii+1)
      yyy=yyy+dlig(j)*eigl(j,ii+2)
      zzz=zzz+dlig(j)*eigl(j,ii+3)
   15 continue
      xxx=xxx+xb(ii+1)
      yyy=yyy+xb(ii+2)
      zzz=zzz+xb(ii+3)
      else
      xxx=xb(ii+1)
      yyy=xb(ii+2)
      zzz=xb(ii+3)
      endif
      xar=xxx*crot+yyy*srot
      yar=-xxx*srot+yyy*crot
      pm(1,1)=-xar*cssp-yar*cp-zzz*sssp
      pm(2,1)=xar*cscp-yar*sp+zzz*sscp
      pm(3,1)=0.0d0
      pm(1,2)=-xar*sscp+zzz*cscp
      pm(2,2)=-xar*sssp+zzz*cssp
      pm(3,2)=-xar*cs-zzz*ss
      pm(1,3)=yar*cscp+xar*sp
      pm(2,3)=yar*cssp-xar*cp
      pm(3,3)=-yar*ss
      do 20 j=1,3
      do 30 k=1,3
      delta(j)=delta(j)+pm(k,j)*f(ii+k)
   30 continue
   20 continue
   10 continue
c     write(*,*)'rota finished'
c     write(*,*)'rotational force',(delta(j),j=1,3)
      return
      end
