      SUBROUTINE MERFI (P,Y,IER)                                        MERI0390
C                                  SPECIFICATIONS FOR ARGUMENTS         MERI0400
      REAL*8             P,Y                                            MERI0410
      INTEGER            IER                                            MERI0420
C                                  SPECIFICATIONS FOR LOCAL VARIABLES   MERI0430
      REAL*8             A,B,X,Z,W,WI,SN,SD,F,Z2,RINFM,A1,A2,A3,B0,B1,  MERI0440
     *                   B2,B3,C0,C1,C2,C3,D0,D1,D2,E0,E1,E2,E3,F0,F1,  MERI0450
     *                   F2,G0,G1,G2,G3,H0,H1,H2,SIGMA                  MERI0460
      DATA               A1/-.5751703/,A2/-1.896513/,A3/-.5496261E-1/   MERI0470
      DATA               B0/-.1137730/,B1/-3.293474/,B2/-2.374996/      MERI0480
      DATA               B3/-1.187515/                                  MERI0490
      DATA               C0/-.1146666/,C1/-.1314774/,C2/-.2368201/      MERI0500
      DATA               C3/.5073975E-1/                                MERI0510
      DATA               D0/-44.27977/,D1/21.98546/,D2/-7.586103/       MERI0520
      DATA               E0/-.5668422E-1/,E1/.3937021/,E2/-.3166501/    MERI0530
      DATA               E3/.6208963E-1/                                MERI0540
      DATA               F0/-6.266786/,F1/4.666263/,F2/-2.962883/       MERI0550
      DATA               G0/.1851159E-3/,G1/-.2028152E-2/               MERI0560
      DATA               G2/-.1498384/,G3/.1078639E-1/                  MERI0570
      DATA               H0/.9952975E-1/,H1/.5211733/                   MERI0580
      DATA               H2/-.6888301E-1/                               MERI0590
      DATA               RINFM/1.7014E+38/                              MERI0600
C                                  FIRST EXECUTABLE STATEMENT           MERI0610
      IER = 0                                                           MERI0620
      X = P                                                             MERI0630
      SIGMA = SIGN(1.0D0,X)                                               MERI0640
C                                  TEST FOR INVALID ARGUMENT            MERI0650
      IF (.NOT.(X.GT.-1.0d0.AND.X.LT.1.0d0)) GO TO 30                   MERI0660
      Z = ABS(X)                                                        MERI0670
      IF (Z.LE.0.85d0) GO TO 20                                           MERI0680
      A = 1.-Z                                                          MERI0690
      B = Z                                                             MERI0700
C                                  REDUCED ARGUMENT IS IN (.85,1.),     MERI0710
C                                     OBTAIN THE TRANSFORMED VARIABLE   MERI0720
    5 W = SQRT(-DLOG(A+A*B))                                            MERI0730
      IF (W.LT.2.5d0) GO TO 15                                            MERI0740
      IF (W.LT.4.0d0) GO TO 10                                             MERI0750
C                                  W GREATER THAN 4., APPROX. F BY A    MERI0760
C                                     RATIONAL FUNCTION IN 1./W         MERI0770
      WI = 1./W                                                         MERI0780
      SN = ((G3*WI+G2)*WI+G1)*WI                                        MERI0790
      SD = ((WI+H2)*WI+H1)*WI+H0                                        MERI0800
      F = W + W*(G0+SN/SD)                                              MERI0810
      GO TO 25                                                          MERI0820
C                                  W BETWEEN 2.5 AND 4., APPROX. F      MERI0830
C                                     BY A RATIONAL FUNCTION IN W       MERI0840
   10 SN = ((E3*W+E2)*W+E1)*W                                           MERI0850
      SD = ((W+F2)*W+F1)*W+F0                                           MERI0860
      F = W + W*(E0+SN/SD)                                              MERI0870
      GO TO 25                                                          MERI0880
C                                  W BETWEEN 1.13222 AND 2.5, APPROX.   MERI0890
C                                     F BY A RATIONAL FUNCTION IN W     MERI0900
   15 SN = ((C3*W+C2)*W+C1)*W                                           MERI0910
      SD = ((W+D2)*W+D1)*W+D0                                           MERI0920
      F = W + W*(C0+SN/SD)                                              MERI0930
      GO TO 25                                                          MERI0940
C                                  Z BETWEEN 0. AND .85, APPROX. F      MERI0950
C                                     BY A RATIONAL FUNCTION IN Z       MERI0960
   20 Z2 = Z*Z                                                          MERI0970
      F = Z+Z*(B0+A1*Z2/(B1+Z2+A2/(B2+Z2+A3/(B3+Z2))))                  MERI0980
C                                  FORM THE SOLUTION BY MULT. F BY      MERI0990
C                                     THE PROPER SIGN                   MERI1000
   25 Y = SIGMA*F                                                       MERI1010
      IER = 0                                                           MERI1020
      GO TO 9005                                                        MERI1030
C                                  ERROR EXIT. SET SOLUTION TO PLUS     MERI1040
C                                     (OR MINUS) INFINITY               MERI1050
   30 IER = 129                                                         MERI1060
      Y = SIGMA * RINFM                                                 MERI1070
 9000 CONTINUE                                                          MERI1080
      write(*,*)'grosser Muell'                                         MERI1090
 9005 RETURN                                                            MERI1100
      END                                                               MERI1110
