      program attractsingle
c
c main program 
c This program performs a single docking minimization.
c usage: $path/attractsingle receptor.pdb ligand.pdb parameterfile
c It requires the following files: 
c  translate.dat, rotation.dat, standard.pdb,attract.inp
c Author: Martin Zacharias, Jacobs University Bremen
c
      include "CADD.t"
      character*100 b,eingabe,eingabe1,eingabe2,filnam
      character*4 atyp(20),rg(5000),rgi(5000),tyi(5000),ty(5000),at,
     1            au,av,typa
      dimension ka(5000),kai(5000),ipol(50),lisrec(20000),iill(5000),
     1          lislig(10000),ialpst(5000),iflo(31,31),ipoint(5000)
      dimension rad(50),amp(50),xla(25000),xlai(25000),theta(20),
     1          xzr(25000),ceest(3),ceend(3),pca(3,3),
     2          abc(31,31),wori(3)
      dimension sasa(9000),sasaf(9000),radi(31),solv(31),csth(80),
     1 snth(80),cphgh(80),sphgh(80),xcrd(9000),ycrd(9000),zcrd(9000)
      dimension ity(9000)
      data (atyp(j),j=1,20)/'ASP ','GLU ','LYS ','ARG ','HIS ','ASN ',
     1 'GLN ','SER ','THR ','CYS ','ALA ','VAL ','ILE ','LEU ','MET ',
     2 'TYR ','TRP ','PHE ','GLY ','PRO '/
c  read file names from command line
      call getarg(1,eingabe) 
      call getarg(2,eingabe1)
      call getarg(3,eingabe2)
c  set some parameters
      permi=15.0D0
      one=1.0D0
      zwei=2.0D0
      xnull=0.0d0
      felec=332.053986d0
      felec=sqrt(felec/permi)
      pi=3.141592654d0
      zwopi=2.0d0*pi
      igb=0
      iconf=1
c
c open and read receptor file
c
      open(42,file=eingabe)
      i=0
      iold=0
      irs=0
      irso=0
      izz=1
   40 read(42,20,end=30) b
      if(b(:4).eq.'ATOM') then
      read(b,26) at,ka(i+1),ty(i+1),rg(i+1),ie(i+1),xc(3*i+1),
     1  xc(3*i+2),xc(3*i+3),iac(i+1),xla(i+1),icopr(i+1),wer(i+1)
      cha(i+1)=felec*xla(i+1)
      ka(i+1)=i+1
c
c this for renumbering of residues
c and identificatin of conformational copies of side chains or loop segments
c
      if(ie(i+1).ne.irso) then
      irso=ie(i+1)
      irs=irs+1
      iold=0
      endif
      ie(i+1)=irs
      if(icopr(i+1).ne.0) then
      izz=izz+1
      else
      izz=0
      endif
      if(icopr(i+1).ne.iold) then
      izz=1
      iold=icopr(i+1)
      endif
c array for the atoms (izz) of each copy (iold) of a residue (irs)
      ncoprez(irs,iold,izz)=i+1
c max number of copies of residue irs 
      nmaxcor(irs)=icopr(i+1)
c max number of copies on residue irs 
      natcor(irs)=izz
      i=i+1
      if(ty(i).eq."CA  ") then 
      ialpr(ie(i))=i
      ix=ix+1
      ica(ix)=i
      else
      nsca(ix)=nsca(ix)+1
      isca(ix,nsca(ix))=i   
      endif
      if(cha(i).ne.xnull) icha(i)=1
      imodel=1
      if(imodel.eq.0) then
      iac(i)=21
      do 11 j=1,20
      if(atyp(j).eq.rg(i).and.ty(i).ne.'CA  ') iac(i)=j
c     if(atyp(j).eq.rg(i)) iac(i)=j
   11 continue
      endif
      endif 
      goto 40
   30 close(42)
      nca=ix
      nresr=ie(i)
      natom=i
      n3=3*natom
c calculate center of receptor
      ce(1)=xnull
      ce(2)=xnull
      ce(3)=xnull
      do 15 i=1,natom
      ii=3*(i-1)
      do 16 j=1,3
      ce(j)=ce(j)+xc(ii+j)
   16 continue
   15 continue
      do 18 j=1,3
      ce(j)=ce(j)/float(natom)
   18 continue
c open input file
      open(47,file='attract.inp')
      read(47,'(4i5,i10)') ilauf,irez,ieigl,idoshake,iter
      read(47,'(4f10.5)') xrst,yrst,zrst,rstk
      idoshake=0
      iter=0
c
c  ilauf: number of energy minimizations
c  irez:  if 1: rezeptor forces in eigenvector direction are used
c  ieigl: if 1: ligand forces in eigenvector direction are used
c  idoshake: if 1: shake is performed after each minimization  
c  xrst,yrst,zrst: restrain origin, rstk=restrain force constant
c
      i=0 
      iold=0
      irs=0
      irso=0
      izz=1
      distalpa=1.0d10
      ialst=0
c open and read ligand protein file
      open(43,file=eingabe1)
  200 read(43,20,end=226) b
c     if(b(:3).eq.'TER') read(b,*) av,(pca(1,j),j=1,3),
c    1 (pca(2,j),j=1,3),(pca(3,j),j=1,3) 
      if(b(:4).eq.'ATOM') then
      read(b,26) at,kai(i+1),tyi(i+1),rgi(i+1),iei(i+1),x(3*i+1),
     1     x(3*i+2),x(3*i+3),iaci(i+1),xlai(i+1),icopl(i+1),wel(i+1)
      chai(i+1)=felec*xlai(i+1)
      kai(i+1)=i+1
c
c this for renumbering of residues
c and identificatin of conformational copies of side chains or loop segments
c
      if(iei(i+1).ne.irso) then
      irso=iei(i+1)
      irs=irs+1
      iold=0
      endif
      iei(i+1)=irs
      if(icopl(i+1).ne.0) then
      izz=izz+1
      else
      izz=0
      endif
      if(icopl(i+1).ne.iold) then
      izz=1
      iold=icopl(i+1)
      endif
c array for the atoms (izz) of each copy (iold) of a residue (irs)
      ncoplig(irs,iold,izz)=i+1
c max number of copies of residue irs 
      nmaxcol(irs)=icopl(i+1)
c max number of copies on residue irs 
      natcol(irs)=izz
      if(tyi(i+1).eq."CA  ") then
c this is to renumber residues
      ialst=ialst+1
      ialpl(ialst)=i+1
c this is to determine the CA that is closest to the center of the receptor
      disa=(x(3*i+1)-ce(1))**2+(x(3*i+2)-ce(2))**2+(x(3*i+3)-ce(3))**2 
         if(disa.le. distalpa) then
         distalpa=disa
         jrst=i
         endif
      endif
      i=i+1
      if(imodel.eq.0) then
      iaci(i)=21
      do 211 j=1,20
      if(atyp(j).eq.rg(i).and.ty(i).ne.'CA  ') iaci(i)=j
c     if(atyp(j).eq.rg(i)) iaci(i)=j
  211 continue
      endif
      if(chai(i).ne.xnull) ichai(i)=1
      endif
      goto 200
  226 close(43)
      nresl=iei(i)
      nlig=i
      n3l=3*nlig
      do 229 i=1,3
      ceest(i)=xnull
  229 continue
c
c read reference structure in file standard.pdb
c this structure is read to compare with the final ligand protein placement
c
      i=1
      istst=0
      ialst=0
      open(49,file='standard.pdb')
  238 read(49,20,end=239) b
      if(b(:4).eq.'ATOM') then
      ii=3*(i-1)
      read(b,'(13x,a4,5x,i4,4x,3f8.3)') typa,itypa,(xzr(ii+j),j=1,3)
      istst=istst+1
      ceest(1)=ceest(1)+xzr(ii+1)
      ceest(2)=ceest(2)+xzr(ii+2)
      ceest(3)=ceest(3)+xzr(ii+3)
      if(typa.eq."CA  ") then
      ialst=ialst+1
      ialpst(ialst)=i
      endif
      i=i+1
      endif
      goto 238
  239 close(49)
      do 241 i=1,3
      ceest(i)=ceest(i)/istst
  241 continue
      ii=0
      do 244 i=1,natom
      if(icha(i).eq.1) then
      ii=ii+1
      ipoicha(ii)=i
      endif
  244 continue
      ipcham=ii
      ii=0
      do 245 i=1,nlig
      if(ichai(i).eq.1) then
      ii=ii+1
      ipoichal(ii)=i
      endif
  245 continue 
      ipchalm=ii
      xrst=x(3*jrst+1)
      yrst=x(3*jrst+2)
      zrst=x(3*jrst+3)
      open(11,file=eingabe2)
      do 443 i=1,31
      read(11,*)(rbc(i,j),j=1,31)
      do 445 j=1,31
      rbc(i,j)=1.0d0*rbc(i,j)
  445 continue
c     write(*,*)(rbc(i,j),j=1,31)
  443 continue
      do 446 i=1,31
      read(11,*)(abc(i,j),j=1,31)
c     write(*,*)(abc(i,j),j=1,31)
  446 continue
      do 447 i=1,31
      read(11,*)(iflo(i,j),j=1,31)
  447 continue
      close(11)
      do 450 j=1,31
      do 448 i=1,31
      rc(i,j)=abc(i,j)*rbc(i,j)**8
      ac(i,j)=abc(i,j)*rbc(i,j)**6
      emin(i,j)=-27.0d0*ac(i,j)**4/(256.0d0*rc(i,j)**3)
      rmin2(i,j)=4.0d0*rc(i,j)/(3.0d0*ac(i,j))
      ipon(i,j)=iflo(i,j)
  448 continue
  450 continue
      iprint=0
      if(iprint.eq.1) then
      write(*,*)'Parameters'
      do 482 i=1,31
      do 483 j=1,31
      write(*,'(2f12.1)')
     1 abc(i,j),rbc(i,j)
  483 continue
  482 continue
      endif
c building electrostatics pairlist, no cutoff!
      jj=0 
      do 500 i=1,natom
      if(ipol(iac(i)).eq.2) then
      jj=jj+1
      irezept(jj)=i
      endif
  500 continue
      ncharez=jj
      jj=0
      do 510 i=1,nlig
      if(ipol(iaci(i)).eq.2) then
      jj=jj+1
      iligand(jj)=i
      endif
  510 continue
      nchalig=jj
c     read harmonic modes, can be used if one wants include ligand flexibility, 
c     this  under development, not well tested!
c     
      if(ieigl.eq.1) then
      if (idoshake.eq.1) then
      do 100 i=1,ncal-1 
      ii=3*(ical(i)-1)
      jj=3*(ical(i+1)-1)
      ibondl(i,1)=ical(i)
      ibondl(i,2)=ical(i+1)
      bondl(i,1)=sqrt((x(jj+1)-x(ii+1))**2+(x(jj+2)-x(ii+2))**2+
     1              (x(jj+3)-x(ii+3))**2) 
      if (i.lt.ncal-1) then
      jj=3*(ical(i+2)-1)
      bondl(i,2)=sqrt((x(jj+1)-x(ii+1))**2+(x(jj+2)-x(ii+2))**2+
     1              (x(jj+3)-x(ii+3))**2) 
      endif
 100  continue
      endif
      itest=int(n3l/6)
      irest=n3l-6*itest
      open(13,file='hml.dat')
      do 530 l=1,15
      read(13,*) kk,vall(l)
      vall(l)=1.0d0*vall(l)*vall(l)
      do 540 i=1,itest
      read(13,*)(eigl(l,6*(i-1)+j),j=1,6)
 540  continue
      if(irest.gt.0) read(13,*)(eigl(l,6*itest+j),j=1,irest)
      write(*,*) 'ligand eigenvector read ',l,kk,vall(l)
 530  continue
      close(13)
      write(*,*) ' check norm and orthogonality of eigenvectors'
      do 542 l=1,5
      eigvall=xnull
      do 545 j=1,n3l
      eigvall=eigvall+eigl(l,j)*eigl(l,j) 
 545  continue
      write(*,*) 'Norm of eigenvector ', l, eigvall
      eigvall=one/dsqrt(eigvall)
      do 546 j=1,n3l
      eigl(l,j)=eigvall*eigl(l,j)
      eigrot(l,j)= eigl(l,j)
 546  continue
      eigvall=xnull
      do 547 k=1,l
      do 548 j=1,n3l
      eigvall=eigvall+eigl(l,j)*eigl(k,j)
 548  continue
      write(*,*) 'Orthogonality of ligand eigenvectors ', l,k,eigvall
 547  continue
 542  continue
      endif
c
c read harmonic modes, can be used if one wants include receptor flexibility, 
c this  under development, not well tested!
c
      if(irez.eq.1) then
c     
c     compute bond table
c     
      if (idoshake.eq.1) then
      do 110 i=1,nca-1 
      ii=3*(ica(i)-1)
      jj=3*(ica(i+1)-1)
      ibondr(i,1)=ica(i)
      ibondr(i,2)=ica(i+1)
      bondr(i,1)=sqrt((xc(jj+1)-xc(ii+1))**2+(xc(jj+2)-xc(ii+2))**2+
     1              (xc(jj+3)-xc(ii+3))**2) 
      if (i.lt.nca-1) then
      jj=3*(ica(i+2)-1)
      bondr(i,2)=sqrt((xc(jj+1)-xc(ii+1))**2+(xc(jj+2)-xc(ii+2))**2+
     1              (xc(jj+3)-xc(ii+3))**2) 
      endif
 110  continue
      endif
     
      itest=int(n3/6)
      irest=n3-6*itest
c     write(*,*)'itest,irest',itest,irest
      open(12,file='hm.dat')
      do 550 l=1,10
      read(12,*) kk,val(l)
      write(*,*) kk,val(l)
      val(l)=1.0d0*val(l)*val(l)
      do 560 i=1,itest
      read(12,*)(eig(l,6*(i-1)+j),j=1,6)
  560 continue
      if(irest.gt.0) read(12,*)(eig(l,6*itest+j),j=1,irest)
      write(*,*) 'eigenvector read ',l,kk,val(l)
  550 continue
      close(12)
c     write(*,*) ' check norm and orthogonality of eigenvectors'
      do 562 l=1,10
      eigval=xnull
      do 565 j=1,n3
      eigval=eigval+eig(l,j)*eig(l,j) 
  565 continue
c     write(*,*) 'Norm of eigenvector ', l, eigval
      eigval=one/dsqrt(eigval)
      do 566 j=1,n3
      eig(l,j)=eigval*eig(l,j)
  566 continue
      eigval=xnull
      do 567 k=1,l
      do 568 j=1,n3
      eigval=eigval+eig(l,j)*eig(k,j)
  568 continue
c     write(*,*) 'Orthogonality of eigenvectors ', l,k,eigval
  567 continue
  562 continue
      endif
c setup of structure vectors 
      do 570 i=1,n3
      yc(iconf,i)=xc(i)
      xzz(i)=xc(i)
      yc(4,i)=xnull
  570 continue
      do 580 i=1,n3l
      xol(i)=x(i)
      y(iconf,i)=x(i)
  580 continue
      xa=xnull
      ya=xnull
      za=xnull
      do 585 i=1,nlig
      jj=3*(i-1)
      xa=xa+x(jj+1)
      ya=ya+x(jj+2)
      za=za+x(jj+3)
  585 continue
      xa=xa/float(nlig)
      ya=ya/float(nlig)
      za=za/float(nlig)
      do 590 i=1,nlig
      jj=3*(i-1)
      xb(jj+1)=x(jj+1)-xa
      xb(jj+2)=x(jj+2)-ya
      xb(jj+3)=x(jj+3)-za
      do 589 k=1,3
      x(jj+k)=xb(jj+k)
  589 continue
  590 continue
      phi=xnull
      ssi=xnull
      rot=xnull
c  assume that the receptor structure is relaxed, set all mode contributions to zero
      if(irez.eq.1) then
      do 595 i=1,neigen
      rez(i)=xnull
  595 continue 
      endif
      if(ieigl.eq.1) then
      do 596 i=1,neigl
      dlig(i)=xnull
 596  continue 
      endif
c check contacts in complex of receptor and standard.pdb
      rcon=5.0d0
      call contact(lisrec,lislig,xzr,ncon,rcon,natr,natl)
c
c get energy and forces
c
      do 3001 ilau=1,ilauf
      read(47,'(i5,8i3,f9.2)')
     1 ivmax,ihes,iori,itra,irez,ieigl,neigl,neigen,irst,rcut
      jb=3*iori+3*itra+irez*neigen
      ju=jb+ieigl*neigl
      jl=jb-3-irez*neigen
      jr=jb-irez*neigen
c
c  if ihess=3 (BD simulation) get relative weights ("diffusion coefficients") for type of motion
      if(ihes.eq.3) then
      wori(1)=0.00061d0
      wori(2)=0.00061d0
      wori(3)=0.00121d0
      wtra=0.01756d0
      weig=0.3d0
      do i=1,3
      do j=1,3
      write(*,*)'pca',pca(i,j)
      enddo
      enddo
      open(57,file='traject.pdb')
      endif
c  if isurf=1 (surface area calculations included)
c  set parameters for SASA calculation
      isurf=0
      if(isurf.eq.1) then
      nphi=8
      ncosth=5
      srad=1.4d0
      open(11,file='solv.dat')
      do 623 i=1,31
      read(11,'(i5,2f7.3)') ii,radi(i),solv(i)
  623 continue
      close(11)
      call surfpara(csth,snth,cphgh,sphgh,nphi,ncosth)
      endif
c
c  check eigenvector forces
c
c     call test
c
c  start docking minimization
c
      call select
      call pairgen 
      call nonbon8
      if(ihes.eq.1) call steep(ivmax)
      if(ihes.eq.2) call minfor(ivmax)
      if(ihes.eq.3) call brow(ivmax,wori,wtra,weig,pca,xzr,ialpst)
      if(idoshake.eq.1) then 
        call shaker(iter)
        call shakel(iter)
      endif
      call pairgen 
      call nonbon8
c     write(*,*)'enon+epote+erest+erezp+enlig',enon,epote,erest,erezp,enlig
      gesa=enon+epote+erest+erezp+enlig
c
c  output coordinates after each docking minimization run
c
      write(filnam,177) ilau
  177 format('lig',i3.3,'.pdb')
      open(55,file=filnam)
      write(55,'(i5)') nlig
      do 485 i=1,nlig
      kk=3*(i-1)
      write(55,26)at,kai(i),tyi(i),rgi(i),iei(i),y(iconf,kk+1),
     1  y(iconf,kk+2),y(iconf,kk+3),iaci(i),xlai(i),icopl(i),wel(i+1)
  485 continue
      write(55,'(a3)')'TER'
      close(55)
 3001 continue
      close(47)
c calculate norm of force
      dnorm=xnull
      do 705 i=1,ju
      dnorm=dnorm+delta(i)**2
  705 continue
      drest=xnull
      do 707 i=jr+1,ju
      drest=drest+delta(i)**2
  707 continue
      dnorm=sqrt(dnorm)
c check surface area + solvation
      if(isurf.eq.1) then
      do 627 i=1,natom
      ii=3*(i-1)
      xcrd(i)=yc(iconf,ii+1)
      ycrd(i)=yc(iconf,ii+2)
      zcrd(i)=yc(iconf,ii+3)
  627 continue
      call surface(xcrd,ycrd,zcrd,iac,radi,sasaf,snth,csth,
     1          cphgh,sphgh,srad,natom,ncosth,nphi,0)
      do 633 i=1,nlig
      ii=3*(i-1)
      xcrd(i)=y(iconf,ii+1)
      ycrd(i)=y(iconf,ii+2)
      zcrd(i)=y(iconf,ii+3)
  633 continue
      call surface(xcrd,ycrd,zcrd,iaci,radi,sasaf,snth,csth,
     1          cphgh,sphgh,srad,nlig,ncosth,nphi,natom)
      sasarec=xnull
      solvrec=xnull
      do 727 i=1,natom
      sasarec=sasarec+sasaf(i)
      solvrec=solvrec+solv(iac(i))*sasaf(i)
      ity(i)=iac(i)
      ii=3*(i-1)
      xcrd(i)=yc(iconf,ii+1)
      ycrd(i)=yc(iconf,ii+2)
      zcrd(i)=yc(iconf,ii+3)
  727 continue
      sasalig=xnull
      solvlig=xnull
      do 733 i=1,nlig
      sasalig=sasalig+sasaf(natom+i)
      solvlig=solvlig+solv(iaci(i))*sasaf(natom+i)
      ity(natom+i)=iaci(i)
      ii=3*(i-1)
      xcrd(natom+i)=y(iconf,ii+1)
      ycrd(natom+i)=y(iconf,ii+2)
      zcrd(natom+i)=y(iconf,ii+3)
  733 continue
      call surface(xcrd,ycrd,zcrd,ity,radi,sasa,snth,csth,
     1          cphgh,sphgh,srad,natom+nlig,ncosth,nphi,0)
      sasatot=xnull
      solvtot=xnull
      do 750 i=1,natom+nlig
      sasatot=sasatot+sasa(i)
      solvtot=solvtot+solv(ity(i))*sasa(i)
  750 continue
      sasadiff=sasatot-sasalig-sasarec
      solvdiff=solvtot-solvlig-solvrec
      endif
c
c compare final placement with reference structure (only CA)
c
      do j=1,3
      ceend(j)=xnull
      enddo
      xdi=xnull
      do 845 i=1,ialst
      ii=3*(ialpl(i) - 1)
      jj=3*(ialpst(i) - 1)
      xdi=xdi+(y(iconf,ii+1)-xzr(jj+1))**2+
     1        (y(iconf,ii+2)-xzr(jj+2))**2+
     2        (y(iconf,ii+3)-xzr(jj+3))**2
      do j=1,3
      ceend(j)=ceend(j)+y(iconf,ii+j)
      enddo
  845 continue
      xdi=sqrt(xdi/ialst)
      dice=xnull
      dste=xnull
      do j=1,3
      ceend(j)=ceend(j)/ialst
      dice=dice+(ceend(j)-ce(j))**2
      dste=dste+(ceend(j)-ceest(j))**2
      enddo
      dice=sqrt(dice)
      dste=sqrt(dste)
c
c compare final contacts with native contacts
c     
c  determine native contacts (assuming standard.pdb is the native ligand placement
      rcut=4.0d0
      call pairgen
c create a pointer first
      k=0
      ik=1
      do i=1,nonp
        if(nonr(i).ne.k) then
         ipoint(ik)=i
         k=nonr(i)
         ik=ik+1
        endif
      enddo  
      ipoint(ik)=nonp+1
      kold=0
      ncontact=0
      irecold=0
      iacc=1
      ialc=1
      nacr=0
      nalr=0
      do j=1,ncon
        irece=lisrec(j)
        if(irece.ne.irecold) then
         kold=kold+1
         irecold=irece
        endif
         iliga=lislig(j)
        do k=kold,ik-1
         if(irece.eq.nonr(ipoint(k))) then
           do i=ipoint(k),ipoint(k+1)-1
             if(nonr(i).eq.irece) then
               if(irece.gt.iacc) then
               iacc=irece
               nacr=nacr+1 
               endif
             if(nonl(i).eq.iliga) then
c check if ligand atom was already counted
               ialc=0
               do jk=1,nalr
               if(iliga.eq.iill(jk)) ialc=1
               enddo
               if(ialc.eq.0) then 
               nalr=nalr+1 
               iill(nalr)=iliga
               endif
c  identical contact found
             ncontact=ncontact+1
             endif
             endif
           enddo
         endif
        enddo
      enddo
c     write(*,*)'nacr,nalr,ncontact',nacr,nalr,ncontact 
c
c  check eigenvector forces
c
c     call test
c     write(*,28)'Number ',kcom,'energy ',gesa,'E-norm  ',drest,
c    1           'F-Norm',dnorm
c
c output only, if converged (dnorm < 1.0) und center of ligand not too far
c
c     if(dnorm.gt.1.0.or.xdi.gt.1000.0.or.gesa.gt.0.0) then
c     write(*,*) 'not converged', dnorm,xdi,gesa
c     write(*,*)'delta',(delta(i),i=1,ju)
c     else
      if(isurf.eq.1) then
      write(*,33)gesa,enon,epote,erezp,dnorm,xdi,dice,
     1 float(ncontact)/float(ncon),float(nacr)/float(natr),
     2 float(nalr)/float(natl),sasadiff,solvdiff,dmod(ssi,zwopi),
     3 dmod(phi,zwopi),dmod(rot,zwopi),xa,ya,za
      else
c     write(*,29) gesa,enon,epote,erezp,dnorm,xdi,dice,
c    1   float(ncontact)/float(ncon),float(nacr)/float(natr),
c    2   float(nalr)/float(natl),dmod(ssi,zwopi),dmod(phi,zwopi),
c    3   dmod(rot,zwopi),xa,ya,za
      write(*,29) 1,gesa,enon,epote,dice,dnorm,xdi,
     1   float(ncontact)/float(ncon),float(nacr)/float(natr),
     2   float(nalr)/float(natl),dmod(ssi,zwopi),dmod(phi,zwopi),
     3   dmod(rot,zwopi),xa,ya,za,0.0,0.0,0.0,0.0,0.0
      endif
c     write(*,*)'delta',(delta(i),i=1,ju)
c
c  open  and output final ligand protein structure after all minimizations
c
      open(45,file='o.pdb')
      jj=0
      write(45,'(i5)') nlig

      do 800 i=1,nlig
      if(iacl(i).eq.1) then
      jj=jj+1
      kk=3*(i-1)
      write(45,26)at,jj,tyi(i),rgi(i),iei(i),y(iconf,kk+1),
     1  y(iconf,kk+2),y(iconf,kk+3),iaci(i),xlai(i),icopl(i),wel(i)
      endif
  800 continue
      write(45,'(a3,9f8.3)')'TER',(pca(1,j),j=1,3),(pca(2,j),j=1,3),
     1 (pca(3,j),j=1,3)
      close(45)
c
c  if rezeptor flexibility is considered: output final receptor coordinates
c
c     if(irez.eq.1) then
      open(46,file='rezo.pdb')
      do 810 i=1,natom
      if(iacr(i).eq.1) then
      kk=3*(i-1)
      write(46,26) at,ka(i),ty(i),rg(i),ie(i),yc(iconf,kk+1),
     1  yc(iconf,kk+2),yc(iconf,kk+3),iac(i),xla(i),icopr(i),wer(i)
      endif
  810 continue
      write(46,'(a3)')'TER'
      close(46)
c     endif
c     endif
   17 format(a4,2f7.3,i3)
   20 format(a100)
   24 format(a4,i7,2x,a4,a4,i5,4x,3f8.3)
   26 format(a4,i7,2x,a4,a4,2x,i3,4x,3f8.3,i5,f8.3,i2,f5.2)
   27 format(a12,3f12.4)
   28 format(a7,i5,a7,f13.4,a7,f13.4,a7,f13.4)
c  29 format(4f11.3,2x,f12.6,f10.2,f10.2)
c  29 format(2f9.3,2f6.2,e8.1,f8.3,f8.2,3f6.3,3f7.3,3f7.2)
c  29 format(i6,2f9.3,e8.1,2f7.2,3f6.3,3f8.4,3f9.4)
   29 format(i6,f9.3,f8.2,f6.1,f7.2,e8.1,f7.2,3f6.3,3f7.3,3f7.2,5f6.1)
   31 format(30x,3f8.3)
   33 format(2f9.3,2f6.2,e8.1,f8.3,f8.2,3f6.3,2f10.3,3f7.3,3f7.2)
 3002 end
