      subroutine select
      include "CADD.t"
c This subroutine goes through all residues and all side chain copies
c The atoms belonging to the energetically most favorable side chain copy
c are selected and labeled active: iacl(i)=1 (iacr(i)=1:receptor) , atoms
c belonging to high energy copies are labeled iacl(i)=0 
c go through all residue pairs with site chain copies
c and select the best copies for building an atom-atom pairlist
c set energy arrays for receptor and ligand (enr(i,j),enl(j,i)) to zero
      do 50 i=1,nresr
      do 60 j=1,nmaxcor(i)
      enr(i,j)=xnull
   60 continue
   50 continue
      do 70 i=1,nresl
      do 80 j=1,nmaxcol(i)
      enl(i,j)=xnull
   80 continue
   70 continue 
c go through all receptor residues
      do 100 i=1,nresr
c go through side chain copies
      do 105 ii=1,nmaxcor(i)
c go copy atoms
      do 107 jj=1,natcor(i)
      irid=ncoprez(i,ii,jj)
      it=iac(irid)
      iii=3*(irid-1)
      et=xnull
c go over all interactions with the ligand
      do 110 j=1,nlig
      jjj=3*(j-1)
      r2=xnull
      do 120 k=1,3
      r2=r2+(y(iconf,jjj+k)-yc(iconf,iii+k))**2
  120 continue
      if(r2.lt.rcut) then
      jt=iaci(j)
      alen=wel(j)*wer(irid)*ac(it,jt)
      rlen=wel(j)*wer(irid)*rc(it,jt)
      ivor=ipon(it,jt)
      charge=wel(j)*wer(irid)*cha(irid)*chai(j)
      r2=r2+0.001d0
      rr2=1.0d0/r2
      if(abs(charge).gt.xnull) et=charge*rr2
      if(r2.lt.rmin2(it,jt)) then
      rr23=rr2**3
      rep=rlen*rr2
      vlj=(rep-alen)*rr23+(ivor-1)*emin(it,jt)
      else
      rr23=rr2**3
      rep=rlen*rr2
      vlj=ivor*(rep-alen)*rr23
      endif
      enr(i,ii)=enr(i,ii)+vlj+et
c     write(*,*)'i,j,vlj',i,ii,j,ncoprez(i,ii,jj),vlj,et
      endif
  110 continue
  107 continue
  105 continue
  100 continue
c now the same for the ligand protein
      do 200 i=1,nresl
      do 205 ii=1,nmaxcol(i)
      do 207 jj=1,natcol(i)
      irid=ncoplig(i,ii,jj)
      it=iaci(irid)
      iii=3*(irid-1)
      et=xnull
c go over all interactions with the receptor
      do 210 j=1,natom
      jjj=3*(j-1)
      r2=xnull
      do 220 k=1,3
      r2=r2+(y(iconf,iii+k)-yc(iconf,jjj+k))**2
  220 continue
      if(r2.lt.rcut) then
      jt=iac(j)
      alen=wer(j)*wel(irid)*ac(jt,it)
      rlen=wer(j)*wel(irid)*rc(jt,it)
      ivor=ipon(jt,it)
      charge=wer(j)*wel(irid)*chai(irid)*cha(j)
      r2=r2+0.001d0
      rr2=1.0d0/r2
      if(abs(charge).gt.xnull) et=charge*rr2
      if(r2.lt.rmin2(jt,it)) then
      rr23=rr2**3
      rep=rlen*rr2
      vlj=(rep-alen)*rr23+(ivor-1)*emin(jt,it)
      else
      rr23=rr2**3
      rep=rlen*rr2
      vlj=ivor*(rep-alen)*rr23
      endif
      enl(i,ii)=enl(i,ii)+vlj+et
c     write(*,*)'i,j,vlj',i,j,ii,jj,ncoplig(i,ii,jj),vlj,et,r2
      endif
  210 continue
c     write(*,*)'i,ii,jj,vlj',i,ii,jj,nmaxcol(i),natcol(i),
c    1 ncoplig(i,ii,jj),enl(i,ii),et
  207 continue
  205 continue
  200 continue
c selection of best copy
      do 250 i=1,nresr
      if(nmaxcor(i).ne.0) then
      enref=enr(i,1)
      ilowr(i)=1
      endif
      do 260 j=2,nmaxcor(i)
      if(enr(i,j).lt.enref) then
      enref=enr(i,j)
      ilowr(i)=j
      endif
  260 continue
  250 continue
      do 350 i=1,nresl
      if(nmaxcol(i).ne.0) then 
      enref=enl(i,1)
c     write(*,*)'enl(i,1)',i,enl(i,1)
      ilowl(i)=1
      endif
      do 360 j=2,nmaxcol(i)
c     write(*,*)'enl(i,j)',i,j,enl(i,j)
      if(enl(i,j).lt.enref) then
      enref=enl(i,j)
      ilowl(i)=j
      endif
  360 continue
  350 continue
c determine active atoms
c the active atom list is used in subroutine pairgen to
c generate an active pairlist which is uded in nonbon8 to calculate
c energy and forces
      do 400 i=1,natom
      ipt=ie(i)
      iacr(i)=0
      if(nmaxcor(ipt).ne.0.and.icopr(i).eq.ilowr(ipt)) iacr(i)=1
      if(nmaxcor(ipt).ne.0.and.icopr(i).eq.0) iacr(i)=1
      if(nmaxcor(ipt).eq.0) iacr(i)=1
  400 continue
      do 450 i=1,nlig
      ipt=iei(i)
      iacl(i)=0
      if(nmaxcol(ipt).ne.0.and.icopl(i).eq.ilowl(ipt)) iacl(i)=1
      if(nmaxcol(ipt).ne.0.and.icopl(i).eq.0) iacl(i)=1
      if(nmaxcol(ipt).eq.0) iacl(i)=1
c     write(*,*)'selection',i,iacl(i)
  450 continue
      return
      end
